/****************************************************************
*								
*		    Explosion Member functions			
*			by Pran Mukherjee
*			pran@umich.edu
*			http://www.erim-int.com/~pran
*			04/15/00
*								
****************************************************************/
#include "Explosion.h"

Explosion::Explosion(int max_p, int max_s, float pos[3], float vel[3]):
ParticleSys(max_p, pos, vel, EXPLOSION)
{
	S_Num_Shards = 0;
	S_Max_Shards = max_s;
}

Explosion::~Explosion()
{
}

Explosion::S_InitExplosion(float dt, float fuel)
{
	float fade, size, mass;		
	float v_tmp[3], c_tmp[4];

//	fprintf(stderr, "Num/Max_Particles_Explo, Age/Max = %d/%2.3f, %f/%f\n", S_Num_Particles, S_Current_Max_P, S_Age, S_Max_Age);
	while ((float)S_Num_Particles < S_Max_Particles)
	{
//		fade = ((float)(rand()%90)+10.0f)/100.0f;		// Set random fade rate  (1 - 10 seconds)
		fade = (((float)(rand()%50)/100.0f)+0.5f);		// Set random fade rate (,5 - 1 seconds
/*
		v_tmp[X] = S_Vel[X] + ((float)(rand()%100)/100-0.5f) * fuel; 
		v_tmp[Y] = S_Vel[Y] +  ((float)(rand()%100)/100-0.5f) * fuel;
		v_tmp[Z] = S_Vel[Z] +  ((float)(rand()%100)/100-0.5f) * fuel;
*/
		v_tmp[X] = ((float)(rand()%100)/100-0.5f) * fuel; 
		v_tmp[Y] = ((float)(rand()%100)/100) * fuel;
		v_tmp[Z] = ((float)(rand()%100)/100-0.5f) * fuel;

		c_tmp[R] = 1.0f;		// Fix this default setting
		c_tmp[G] = 0.25f + (float)(rand()%50)/100;
		c_tmp[B] = 0.25f + (float)(rand()%25)/100;
		c_tmp[A] = 1.0f;												

		mass = 1.0f;				// Fix this, too
		size = 2.0f + (float)(rand()%2);

		this->S_AddParticle(S_Pos, v_tmp, c_tmp, size, mass, fade, S_NO_KEEP);		// For now, do not keep any attached systems (shouldn't be any)
	}
/*
	for (int i = 0; i < num_s; i++){
		if (S_Num_Shards <= S_Max_Shards)
		{
			AddShard();
			S_Num_Shards++;
		}
		else
		{
			return(false);
		}
	}
*/
	return(true);
}

Explosion::S_UpdateSystem(float dt)
{
	if (0 == S_Num_Particles) 
	{
		if (RS_Parent) RS_Parent->RS_DeleteSystem(this);
		else if (P_Parent) P_Parent->P_DeleteSystem(this);
		else this->~Explosion();
	}
	return(true);
}
