/****************************************************************
*								
*			C++ Explosion Routines				
*			by Pran Mukherjee
*			pran@umich.edu
*			http://www.erim-int.com/~pran
*			04/15/00
*								
****************************************************************/

#ifndef _Explosion_h
#define _Explosion_h 1

#include "ParticleAPI.h"
#include "ParticleSys.h"
//#include "RootSystem.h"

extern float dt;

class Explosion : public ParticleSys
{
private:	
	int S_Num_Shards;
	int S_Max_Shards;
	Shard *sh;									  //  Head of shard linked list (NOTE:  These cannot have their own systems attached)

public:
	//	Constructor
	Explosion(int max_p, int max_s, float pos[], float vel[]);
	// Destructor
	~Explosion();

	S_UpdateSystem(float dt);		/* This is overriding a virtual function in ParticleSys */
	S_InitExplosion(float dt, float fuel);
};

#endif
