/****************************************************************
*								
*		    Firework Member functions			
*			by Pran Mukherjee
*			pran@umich.edu
*			http://www.erim-int.com/~pran
*			04/15/00
*								
****************************************************************/
#include "Firework.h"

Firework::Firework(int max_p, float pos[3], float vel[3]):
ParticleSys(max_p, pos, vel, FIREWORK)
{
}

Firework::~Firework()
{
}

Firework::S_InitFirework(float fuel)	/* Don't need SP_Vel_Init or S_Max_Age*/
{
	float fade, size, mass;		
	float v_tmp[3], c_tmp[4];

	while ((float)S_Num_Particles < S_Max_Particles)
	{
		fade = (((float)(rand()%50)/100.0f)+0.5f);  // Set random fade rate (,5 - 1 seconds

		v_tmp[X] = S_Vel[X] + ((float)(rand()%100)/100-0.5f) * fuel; 
		v_tmp[Y] = S_Vel[Y] + ((float)(rand()%100)/100-0.1f) * fuel;
		v_tmp[Z] = S_Vel[Z] + ((float)(rand()%100)/100-0.5f) * fuel;

		c_tmp[R] = 1.0f;		// Fix this default setting
		c_tmp[G] = 0.25f + (float)(rand()%50)/100;
		c_tmp[B] = 0.25f + (float)(rand()%25)/100;
		c_tmp[A] = 1.0f;												

		mass = 0.0005f;				// Fix this, too
		size = 4.0f + (float)(rand()%2);

		S_AddParticle(S_Pos, v_tmp, c_tmp, size, mass, fade, S_KEEP);			// Keep attached systems (should all be short duration anyhow)
	}
	return(true);
}

Firework::S_UpdateSystem(float dt)
{
	if (0 == S_Num_Particles) 
	{
		if (RS_Parent) RS_Parent->RS_DeleteSystem(this);
		else if (P_Parent) P_Parent->P_DeleteSystem(this);
		else this->~Firework();
	}
	return(true);
}
