/****************************************************************
*								
*			C++ Particle API Routines, includes, and data types
*			by Pran Mukherjee
*			pran@umich.edu
*			http://www.erim-int.com/~pran
*			04/15/00
*
*			TO DO:
*					put Particle as contained class within ParticleSys
*							(this next one will be hard due to interlinked nature or ParticleSys and Particle)
*							(use virtual functions for update, draw, etc)
*					break out separate particle/anchor types as classes that inherit Particle  
*
*					add I/O methods for particle data (both GL and non-GL) (textured quad, text I/O, etc)
*					Possibly add dynamic forces PER PARTICLE (viscosity, electromagnetic forces, gravity, etc)
*					Deal with particle mass and forces
*					Add a Shards class for explosions (maybe ONLY explosions?)
*					Add in distance-queuing for particle size, number, etc (so that smoke or whatever looks good close up and far away)
*
*			NOTES:
*		This is a very difficult project since the classes are all multiply-linked back and forth
*		A ParticleSys contains Particles, while each Particle can have attached to it other ParticleSys	groups
*		This makes a mess of the header files.
*									
****************************************************************/

#ifndef ParticleAPI_h
#define ParticleAPI_h 1
#include <windows.h>				// Header File For Windows
#include <stdio.h>
#include <stdlib.h>			
#include <math.h>

// useful macro to guarantee that values are within a given range
#define Clamp(x, min, max)  x = (x<min  ? min : x<max ? x : max);

enum {X, Y, Z, W};		    // axes
enum {R, G, B, A};		    // colors
enum _type_e {NONE, SMOKE, FLAME, SHOT, EXPLOSION, FIREWORK, CONTRAIL, FOUNTAIN};		// types of systems and anchors (separate?)
typedef _type_e PS_Type, Anchor_Type;

enum OUT_Type {OGL_PT, OGL_QUAD, POV};				// Types of output.   Expand this at will
enum {S_NO_KEEP, S_KEEP};											//  Keep systems attached to dead particle or not?

class Particle;
class Shard;					// Not yet defined in any way
class ParticleSys;
class RootSystem;

#include <gl\gl.h>					// Header File For The OpenGL32 Library
#include <gl\glaux.h>				// Header File For The Glaux Library

typedef struct 
{
	OUT_Type o_type;		//  Mode of system output 
	GLuint	image;							// ALL THIS NEEDS TO BE REWORKED AS CONDITIONAL ON WHETHER OR NOT IT'S USED		
	GLuint	texture[1];					// Storage For Our Particle Texture
} PS_Modes;


#endif
