/****************************************************************
*								
*			C++ Particle System Routines				
*			by Pran Mukherjee
*			pran@umich.edu
*			http://www.erim-int.com/~pran
*			04/15/00
*
*			TO DO:
*				Have particles split as they rise and fade, rather than simply grow
*								
****************************************************************/

#ifndef _Smoke_h
#define _Smoke_h 1

#include "ParticleAPI.h"
#include "ParticleSys.h"

extern float dt;

class Smoke : public ParticleSys
{
private:
	float SP_Vel_Init[3];			// Initial relative speed of particle (relative to S_Vel)			
	float S_Age;
	float S_Max_Age;					// In seconds

public:
	//	Constructor
	Smoke(int max_p, float max_a, float pos[], float vel[], float p_vel[]);
	// Destructor
	~Smoke();

	S_UpdateSystem(float dt);		/* This is overriding a virtual function in ParticleSys */
};

#endif
